#include "xmc.h"
#include <fcntl.h>
#include <db.h>
/*--------------------------------------------------------------------- */
/* dbopen : expstr 	-> db | nil 					*/
/* dbclose : bd    	-> nil 						*/
/* dbget : bd Any 	-> int | nil 					*/
/* dbput : bd Any Any 	-> int | nil 					*/
/* dbdel : bd Any 	-> int | nil 					*/
/*--------------------------------------------------------------------- 
   see the use of 
          str2sexp
          sexp2str
--------------------------------------------------------------------- */

extern SEXP str2sexp();
/* dbopen : expstr -> db | nil */
SEXP db1open( args )
SEXP args ;
{
   DB *db;
   db=dbopen(arg_n(1,args,STR)->n_str, O_CREAT|O_RDWR, 0600, DB_BTREE, NULL);
   return(fpsexp((void *) db));
}

/* dbclose : bd -> nil */
static SEXP dbclose( args )
SEXP args ;
{
    DB *db;
    db = (DB *)arg_n(1,args,FPTR)->n_fp;    
    db->close(db);
    return((SEXP) NULL);
}

static char S1[1000]; /* buffer de leituras... */
static char S[20000]; /* buffer de leituras... */

/* dbget : bd -> ANY | nil */
static SEXP dbget( args )
SEXP args ;
{
    DB* db;
    DBT chave,info;
    int status;
    db =(DB *)   arg_n(1,args,FPTR)->n_fp;    

    sexp2str(S1,arg_n(2,args,0));    
    chave.data = S1;
    chave.size = strlen(chave.data);

    info.data =  S;
    status=db->get(db,&chave,&info,0);
    return ( (status==0)? str2sexp(info.data): (SEXP) NULL);
}

/* dbput : bd x ANY x ANY -> int | nil */
static SEXP dbput( args )
SEXP args ;
{
    DB* db;
    DBT chave,info;
    int status;
    db = (DB *)  arg_n(1,args,FPTR)->n_fp;    

    sexp2str(S1,arg_n(2,args,0));    
    chave.data = S1;
    chave.size = strlen(chave.data);

    sexp2str(S, arg_n(3,args,0));    
    info.data =  S;
    info.size = strlen(info.data);
    status=db->put(db,&chave,&info,0);
    return ( (status==0)? (SEXP) NULL : intsexp(status));
}

/* dbdel : bd x ANY -> int | nil */
static SEXP dbdel( args )
SEXP args ;
{
    DB* db;
    DBT chave,info;
    int status;
    db =(DB *)   arg_n(1,args,FPTR)->n_fp;    

    sexp2str(S1,arg_n(2,args,0));    
    chave.data = S1;
    chave.size = strlen(chave.data);

    status=db->del(db,&chave,0);
    return ( (status==0)? (SEXP) NULL : intsexp(status));
}


void userinit()
{   xlsubr( "dbopen", db1open ) ;
    xlsubr( "dbclose", dbclose ) ;
    xlsubr( "dbget", dbget ) ;
    xlsubr( "dbput", dbput ) ;
    xlsubr( "dbdel", dbdel ) ;
}
