#include <stdio.h>
#include "xmc.h"
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <db.h>

/* dbopen : expstr -> db | nil */
SEXP db1open( args )
SEXP args ;
{
   DB *db;
   db=dbopen(arg_n(1,args,STR)->n_str, O_CREAT|O_RDWR, 0600, DB_BTREE, NULL);
   return(fpsexp((FILE*) db));
}

/* dbclose : bd -> nil */
static SEXP dbclose( args )
SEXP args ;
{
    DB *db;
    db = (DB *)arg_n(1,args,FPTR)->n_fp;    
    db->close(db);
    return((SEXP) NULL);
}

/* dbget : bd * str -> str | nil */
static SEXP dbget( args )
SEXP args ;
{
    DB* db;
    DBT chave,info;
    int status;
    db =(DB *)   arg_n(1,args,FPTR)->n_fp;    
    chave.data = arg_n(2,args,STR)->n_str;    
    chave.size = strlen(chave.data);
    status=db->get(db,&chave,&info,0);
    return ( (status==0)? strsexp(info.data): (SEXP) NULL);
}

/* dbput : bd * str * str -> str | nil */
static SEXP dbput( args )
SEXP args ;
{
    DB* db;
    DBT chave,info;
    int status;
    db = (DB *)  arg_n(1,args,FPTR)->n_fp;    
    chave.data = arg_n(2,args,STR)->n_str;    
    info.data =  arg_n(3,args,STR)->n_str;    
    chave.size = strlen(chave.data);
    info.size = strlen(info.data);
    status=db->put(db,&chave,&info,R_NOOVERWRITE);
    return ( (status==0)? strsexp(info.data): (SEXP) NULL);
}

void userinit()
{   xlsubr( "dbopen", db1open ) ;
    xlsubr( "dbclose", dbclose ) ;
    xlsubr( "dbget", dbget ) ;
    xlsubr( "dbput", dbput ) ;
}
