/*---------------------------------------------------------------------------*/
/* xlib.c                                                                    */
/*---------------------------------------------------------------------------*/

#include <varargs.h>
#include <string.h>
#include <stdio.h>

static char strg[255]; /* A string a construir que sera passada ao XMETOO */

#define _UNIX_

#define INPUT     0
#define OUTPUT    1

int sp;   /* stack pointer */

#define MAX_STACK 20  /* n max de elementos do stack */
#define MAX_STRG 255  /* n max duma string do stack */

char a[MAX_STACK][MAX_STRG];

char *manda_x();

#define error(func) if (func != 0) { perror("pipe"); exit(-1);}

/*---------------------------------------------------------------------------*/
FILE * fd2[2];
init()
{char aux;
   error(p2open("xmetoo -n",fd2));
   /* Receber ate ao prompt inicial*/
   do { aux =fgetc(fd2[1]); } while(aux != 0);
}

/*---------------------------------------------------------------------------*/

char *mklist(header, va_alist)
char *header;
va_dcl
{
   va_list ap;

   va_start(ap);
   strcpy(strg, "(list");
   poe_strg(header, ap, 0);
   strcat(strg, ")");
   return(manda_x(strg));
}
/*---------------------------------------------------------------------------*/
char *mkset(header, va_alist)
char *header;
va_dcl
{
   va_list ap;

   va_start(ap);
   strcpy(strg, "(makeset");
   poe_strg(header, ap, 0);
   strcat(strg, ")");
   return(manda_x(strg));
}
/*---------------------------------------------------------------------------*/
char *mkfunc(header, va_alist)
char *header;
va_dcl
{
   va_list ap;

   va_start(ap);
   strcpy(strg, "(");
   poe_strg(header, ap, 0);
   strcat(strg, ")");
   return(manda_x(strg));
}
/*---------------------------------------------------------------------------*/
char *mkff(header, va_alist)
char *header;
va_dcl
{
   va_list ap;

   va_start(ap);
   strcpy(strg, "(makeff");
   poe_strg(header, ap, 1);
   strcat(strg, ")");
   return(manda_x(strg));
}
/*---------------------------------------------------------------------------*/
char *mkrel(header, va_alist)
char *header;
va_dcl
{
   va_list ap;

   va_start(ap);
   strcpy(strg, "(makerel");
   poe_strg(header, ap, 1);
   strcat(strg, ")");
   return(manda_x(strg));
}
/*---------------------------------------------------------------------------*/
poe_strg(head, ap, paren)
char *head;
va_list ap;   /* Aponta para o proximo argumento (de qualquer tipo) */
int paren;
{
   int i,k;       /* Indice do 1. parametro da chamada (que indica os tipos) */

   char *st;      /* Pointer para uma string dos parametros */
   char c;
   int d;         /* N. extraido dos paramteros */
   unsigned int u;
   long l;
   float f;
   double g;
   char aux[255];

   i = 0;
   k = 1;
   while (head[i]) {
      if (paren && k % 2 == 1) strcat(strg, "(");
      else strcat(strg, " ");
      switch (head[i+1]) {
         case 's':   /* string */
            st = va_arg(ap, char *);
            sprintf(aux, "%s", st);
            break;
         case 'c':   /* char */
#ifdef _UNIX_   /* ou XENIX */
            c = va_arg(ap, int);
#else
            c = va_arg(ap, char);
#endif
            sprintf(aux, "%c", c);
            break;
         case 'd':   /* decimal */
            d = va_arg(ap, int);
            sprintf(aux, "%d", d);
            break;
         case 'u':   /* unsigned int */
            u = va_arg(ap, unsigned int);
            sprintf(aux, "%u", u);
            break;
         case 'l':   /* long */
            l = va_arg(ap, long);
            sprintf(aux, "%ld", l);
            i++;
            break;
         case 'f':   /* float ou double: os floats passam a double */
            f = va_arg(ap, double);
            sprintf(aux, "%f", f);
            break;
         default:   /* Erro */
            printf("Erro\n");
            exit();
      }
      strcat(strg, aux);
      i += 2;
      if (paren && k % 2 == 0) strcat(strg, ")");
      k++;
   }
   va_end(ap);
}
/*---------------------------------------------------------------------------*/
char *manda_x(strg)
char *strg;
{
   char buf[1024], *aux;

  printf("vou mandar: %s\n", strg); 
   fprintf(fd2[0],"%s\n",strg);
   fflush(fd2[0]);
   /* Receber */
   buf[0] = '\0'; aux = buf;
   do {
      *aux =fgetc(fd2[1]);
   } while(*(aux++) != '\0');
   aux--;   /* para retirar o \n da strg */
   *aux = '\0';
   printf("recebi %s", buf);
   strcpy(a[sp], buf);
   if (sp < MAX_STACK) return(a[sp++]);
   else {
      printf(stderr, "Ultrapassou o limite do stack\n");
      return(0);
   }
}
/*---------------------------------------------------------------------------*/
eval(strg, R)
char *strg;
char *R;
{
   strcpy(R, strg);
   sp = 0;
}
/*---------------------------------------------------------------------------*/
main()
{
   char R[255];

   init();
   manda_x(" ");
   mklist("%s%u%d%d%d", "l", (unsigned)60000, 5, 314, 999);
   mkset("%d%d%d", 4, 3, 7);
   mkfunc("%s%d%d", "add", 4, 5);
   mkff("%c%c%c%c", 'a', 'b', 'c', 'd');
   mkrel("%c%c%c%c", 'a', 'b', 'c', 'd'); 
   eval(mkff("%s%s", mkfunc("%s%d%d", "add", 4, 5), mkset("%d%d%d", 4, 3, 7)), R);
   printf("R=%s\n", R);
}
