#include <stdio.h>
#include "xmc.h"

DllExport int arg_number(l)  /* pode ser melhorado ... */
SEXP l;
{ int n=0 ;
  SEXP x=NULL;
  if(l != XM_ERROR)
  for( x = l ? l->n_head : x ;
       l != NULL;
       l = l->n_tail, x = l?l->n_head:x)
  { while( (x != NULL) && (x->n_type >= USERDEFTYPE) ) x = x->n_symvalue ;
    n++;
  }
  return(n);
}

DllExport SEXP arg_n(n,l,t)
int n,t;
SEXP l;
{SEXP aux;
 aux = getele(n,l); 
 if(aux==XM_ERROR) xlfail("invalid number of arguments");
 aux=xleval(aux);
 if(t==0 || 
   (aux==NULL && (t==LIST || t==FF || t==SET || t==REL)) || 
   (aux!=NULL && t==aux->n_type)) return(aux);
 xlfail("invalid argument"); 
}

DllExport SEXP arg_n_opt(n,l,t)
int n,t;
SEXP l;
{SEXP aux;
 aux = getele(n,l); 
 if(aux==XM_ERROR) return (XM_ERROR) ;
 aux=xleval(aux);
 if(t==0 || 
   (aux==NULL && (t==LIST || t==FF || t==SET || t==REL)) || 
   (aux!=NULL && t==aux->n_type)) return(aux);
 xlfail("invalid argument"); 
}

DllExport SEXP getele(n,l)
int n;
SEXP l;
{ SEXP x=NULL;
  if(l != XM_ERROR)
  for( x = l ? l->n_head : x ;
       l != NULL;
       l = l->n_tail, x = l?l->n_head:x)
  { while( (x != NULL) && (x->n_type >= USERDEFTYPE) ) x = x->n_symvalue ;
    if (--n == 0) return (x);
  }
  return(XM_ERROR);
}

DllExport SEXP conssexp(h,t)  /* faz uma lista acrescentando h `a cabe,ca de t */
SEXP h,t;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = h;
  nptr->n_tail = t;
  return(nptr);
}

DllExport SEXP l1sexp(s)  /* faz uma lista de 1 SEXP */
SEXP s;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = s;
  nptr->n_tail = NULL;
  return(nptr);
}

DllExport SEXP l2sexp(s1,s2)  /* faz uma lista de 2 SEXP */
SEXP s1,s2;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = s1;
  nptr->n_tail = l1sexp(s2);
  return(nptr);
}

DllExport SEXP l3sexp(s1,s2,s3)  /* faz uma lista de 3 SEXP */
SEXP s1,s2,s3;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = s1;
  nptr->n_tail = l2sexp(s2,s3);
  return(nptr);
}

DllExport SEXP l4sexp(s1,s2,s3,s4)  /* faz uma lista de 4 SEXP */
SEXP s1,s2,s3,s4;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = s1;
  nptr->n_tail = l3sexp(s2,s3,s4);
  return(nptr);
}

DllExport SEXP l5sexp(s1,s2,s3,s4,s5)  /* faz uma lista de 5 SEXP */
SEXP s1,s2,s3,s4,s5;
{ SEXP nptr;
  nptr = newnode(LIST);
  nptr->n_head = s1;
  nptr->n_tail = l4sexp(s2,s3,s4,s5);
  return(nptr);
}

#ifdef    REAL_NUMBER
DllExport SEXP numsexp(s)  /* faz uma lista de 1 SEXP */
double s;
{ SEXP nptr;
  nptr = newnode(NUM);
  nptr->n_num = s;
  return(nptr);
}
#else  /* REAL_NUMBER */
DllExport SEXP intsexp(s)  /* faz uma lista de 1 SEXP */
int s;
{ SEXP nptr;
  nptr = newnode(INT);
  nptr->n_int = s;
  return(nptr);
}
#endif /* REAL_NUMBER */

DllExport SEXP strsexp(s)  /* faz uma lista de 1 SEXP */
char * s;
{ SEXP nptr;
  nptr = newnode(STR);
  nptr->n_str = strsave(s);
  return(nptr);
}

DllExport SEXP fpsexp(s)  /* faz uma SEXP com uma FILE */
FILE *s;
{ SEXP nptr;
  nptr = newnode(FPTR);
  nptr->n_fp = s;
  return(nptr);
}

/*--------------------------------------------------------------------- */
#include <ctype.h>
 /* #include "xmetoo.h"*/

#define sputc(c,S) {*(S++)=c;*S=0;}

/*. m2writestr - output a string into a file .*/
static char* JJm2writestr( fp, str )
char *fp ;
char *str ;
{
    int ch ;

    /* output the initial quote */
    sputc( '"', fp ) ;

    /* output each character in the string */
    while( ch = *str++ )

        /* check for a control character */
        if( (ch < 040) || (ch == '\\') ) {
            sputc( '\\', fp ) ;
            switch( ch ) {
            case '\033' :
                sputc( 'e', fp ) ; 
                break ;
            case '\n' :
                sputc( 'n', fp ) ;
                break ;
            case '\r' :
                sputc( 'r', fp ) ; 
                break ;
            case '\t' :
                sputc( 't', fp ) ; 
                break ;
            case '\\' :
                sputc( '\\', fp ) ;
                break;
            default :
                fp +=sprintf( fp, "%03o", ch ) ;
                break ; } }
        else {
        /* output a normal character */
            sputc( ch, fp ) ; }

    /* output the terminating quote */
    sputc( '"', fp ) ; 
   return fp;
}


/*. m2write - builtin function m2write .*/
/*. m2write : expfptr exp -> nil .*/

static char * JJm2writeaux( fp, vptr )
char *fp ;
struct node *vptr ;
{
    struct node m2rec ;
    struct node *oldstk ;
    struct node *nptr, *next ;
#ifdef USERTYPE
    extern struct t_table *name_table[] ;
    struct t_table *tdef ;
    struct lab_type *ptup ;
    struct node *tl ;
#endif

    /* print null as the empty list */
    if( vptr == NULL ) {
        fp += sprintf( fp, "()\n" ) ;
        return fp ; }

    /* create a new stack frame */
    oldstk = xlsave( &m2rec, NULL ) ;

    /* check value type */
    switch( vptr->n_type ) {
#ifdef LAZY
    case REC :
        fp=JJm2writeaux( fp, xleval( vptr ) ) ;
        break ;
    case LISTREC :
        m2rec.n_ptr = vptr ;
        fp += sprintf( fp, "(list " );
        fp=JJm2writeaux( fp, xleval( m2rec.n_ptr->n_listvalue ) ) ;
        m2rec.n_ptr = m2rec.n_ptr->n_listnext ;
        do {
            m2rec.n_ptr = xleval( m2rec.n_ptr ) ;
            if( (m2rec.n_ptr != NULL) && (m2rec.n_ptr->n_type != LISTREC) )
                xlfail( "bad argument type" ) ;
            if( m2rec.n_ptr != NULL ) {
                sputc( ' ', fp ) ; 
                fp=JJm2writeaux( fp, xleval( m2rec.n_ptr->n_listvalue ) ) ;
                m2rec.n_ptr = m2rec.n_ptr->n_listnext ; }
        } while( m2rec.n_ptr != NULL ) ;
        sputc( ')', fp ) ;
        sputc( '\n', fp ) ;
        break ;
#endif
    case REL :
        fp += sprintf( fp, "(makerel " ) ;
        goto label2 ;
    case FF :
        fp += sprintf( fp, "(makeff " ) ;
label2: for( nptr = vptr ; nptr != NULL ; nptr = next ) {
            sputc( '(', fp ) ;
            fp=JJm2writeaux( fp, nptr->n_listvalue->n_listvalue ) ;
            sputc( ' ', fp ) ;
            fp=JJm2writeaux( fp, nptr->n_listvalue->n_listnext->n_listvalue ) ;
            sputc( ')', fp ) ; 
            if( (next = nptr->n_listnext) != NULL )
                sputc( ' ', fp ) ;}
        sputc( ')', fp ) ; 
        sputc( '\n', fp ) ; 
        break ;
    case SET :
        fp +=sprintf( fp, "(makeset " ) ;
        goto label1 ;
    case LIST :
        fp +=sprintf( fp, "(list " ) ;
label1: for( nptr = vptr ; nptr != NULL ; nptr = next ) {
            fp=JJm2writeaux( fp, nptr->n_listvalue ) ;
            if( (next = nptr->n_listnext) != NULL )
                sputc( ' ', fp ) ;} 
        sputc( ')', fp ) ;
        sputc( '\n', fp ) ; 
        break ;
    case SYM :
        fp += sprintf( fp, "'%s ", vptr->n_symname ) ;
        break ;
    case INT :
#ifdef    REAL_NUMBER
        fp += sprintf( fp, "%g ", vptr->n_int ) ;
#else  /* REAL_NUMBER */
        fp += sprintf( fp, "%d ", vptr->n_int ) ;
#endif /* REAL_NUMBER */
        break ;
    case STR :
        fp =JJm2writestr( fp, vptr->n_str ) ;
        break ;
    case SUBR :
        xlfail( "SUBR cannot be written into a file" ) ;
        break ;
    case FPTR :
        xlfail( "FPTR cannot be written into a file" ) ;
        break;
#ifdef COMM
    case CHAN :
        xlfail( "CHAN cannot be written into a file" ) ;
        break ;
#endif
#ifdef USERTYPE
    case TYPE:
        xlfail( "TYPE cannot be written into a file" ) ;
        break ;
    case LABEL:
        xlfail( "LABEL cannot be written into a file" ) ;
        break ;
    case MACTYPE:
        xlfail( "MACTYPE cannot be written into a file" ) ;
        break ;
#endif
    case FUN :
        xlfail( "FUN cannot be written into a file" ) ;
        break ;
    default:
#ifdef USERTYPE
        if( vptr->n_type >= USERDEFTYPE ) {
            tdef = name_table[vptr->n_type - USERDEFTYPE] ;
            fp += sprintf( fp, "(%s ", tdef->tname ) ;
            if( tdef->tnumber == TTUP ) {
                if( ((tl = vptr->n_symvalue) == NULL) || (tl->n_type != LIST) )
                    xlfail( "type mismatch" ) ;
                for( ptup = tdef->def.tcomp ; (ptup != NULL) && (tl != NULL);
                               ptup = ptup->next, tl = tl->n_listnext )
                     fp=JJm2writeaux( fp, tl->n_listvalue ) ;
                if( (ptup != NULL) || (tl != NULL) )
                    xlfail( "type mismatch" ) ; }
            else
                fp=JJm2writeaux( fp, vptr->n_symvalue ) ;
            sputc( ')', fp ) ; 
            sputc( '\n', fp ) ;}
        else
#endif
        xlfail( "bad node type" ) ; }
return fp;
}

DllExport void sexp2str( S,args )
char* S;
SEXP args ;
{
    JJm2writeaux( S, args ) ;
}

static char *sgetptr;
extern int (*xlgetc)() ;
extern SEXP labeval();

/* sgetc - get a character from the string sgetptr*/
static int sgetc()
{
    if( *sgetptr == 0 ) return( -2 ) ;
    else                return( (int)*sgetptr++ ) ;
}


DllExport SEXP str2sexp( str1 )
char *str1;
{
    SEXP val ;
    int (*oldgetc)() ;

    /* save the old input stream */
    oldgetc = xlgetc ;

    sgetptr =  str1  ;
    xlgetc = sgetc ;

    /* read an expression */
    val = xlread( (FILE *)NULL ) ;

    /* restore the old input stream */
    xlgetc = oldgetc ;

    /* return the expression read */
    return( labeval(val)) ;
}

