/* xmetoo.c - main module */

#include <stdio.h>
#include <setjmp.h>
#include "xmetoo.h"
#include <signal.h>

/* external variables */
extern struct node *xlenv ;
extern struct node *xlstack ;

extern int neverprompt,PP;

extern char jjbuf[BUFSIZ];
extern void usersigint();


/* external procedures */
/*extern int setjmp() ; */
extern void        xltin() ;
extern struct node *load() ;
extern struct node *xlreadfromstr( ) ;
extern void        xlprint() ;
extern void        xmdmeminit() ;
extern void        xmreadinit() ;
extern void        xmevalinit() ;
extern void        xmprintinit() ;
extern void        xmsaveinit() ;
extern void        xmdefinit() ;
#ifdef USERTYPE
extern void        xmutypeinit() ;
#endif
extern void        xmxlispinit() ;
extern void        xmboolinit() ;
#ifdef    REAL_NUMBER
extern void        xmnuminit() ;
#else  /* REAL_NUMBER */
extern void        xmintinit() ;
#endif /* REAL_NUMBER */

extern void        xmstrinit() ;
#ifdef DLL
extern void        dllinit() ;
#endif
extern void        pipeinit() ;
#ifdef COMM
extern void        xmmsginit() ;
#endif
extern void        xmfioinit() ;
extern void        xmlistinit() ;
extern void        xmsetinit() ;
extern void        xmrelinit() ;
extern void        xmffinit() ;
extern void        userinit() ;
extern void        userinit2() ;
extern void ppaux() ;

/* global variables */
extern jmp_buf xljmpbuf ;
struct node *oblist ;
struct node *oblimit ;
struct node lbda_env ;


/*. main - the main routine .*/
main( argc, argv )
int argc ;
char *argv[] ;
{
#include "version"
    struct node expr ;

    int i, first_pass ;
    int first_file=1;
#ifdef __TURBOC__
   /*     int i ; */
#else
    
if(argc>1 && strcmp(argv[1],"-n")==0)
 { setvbuf(stdout,jjbuf,_IOLBF,BUFSIZ);
   first_file=2;
   neverprompt=TRUE; }
#endif
   if(!neverprompt)
   { printf( "\nUM-XMETOO version %s",xm_version ) ;
#ifdef LAZY
     printf( ".LAZY" ) ;
#endif
#ifdef DLL
     printf( ".DLL" ) ;
#endif
#ifdef COMM
     printf( ".COMM" ) ;
#endif
#ifdef USERTYPE
     printf( ".USERTYPE" ) ;
#endif
     printf( " (aap/pem/cjr/jj %s)\n",xm_date ) ;
  }

    oblist = NULL ;

    /* initialize the dynamic memory module (must be first) */
    xmdmeminit() ;

    xmreadinit() ;
    xmevalinit() ;
    xmprintinit() ;
    xmsaveinit() ;
    xmdefinit() ;
#ifdef USERTYPE
    xmutypeinit() ;
#endif
    xmxlispinit() ;
    xmboolinit() ;
    xmintinit() ;
    xmstrinit() ;
#ifdef DLL
    dllinit() ;
#endif
    pipeinit();
#ifdef COMM
    xmmsginit() ;
#endif
    xmfioinit() ;
    xmlistinit() ;
    xmsetinit() ;
    xmrelinit() ;
    xmffinit() ;
    userinit() ; /*for user define inicializations: JJ 1994 (nop by default)*/

    /* delimitates reserved area in oblist */
    oblimit = oblist->n_symvalue ;

    /* initialize terminal input */
    xltin( FALSE ) ;

    /* set error jump address */
    first_pass = TRUE ;
    userinit2() ; /*for user define inicializations: JJ 1994 (nop default)*/
    setjmp( xljmpbuf ) ;
    signal(SIGINT,usersigint);

    if( first_pass ) {
        first_pass = FALSE ;
        /* initialize stack and evaluation environment */
        xlstack = xlenv = NULL ;
        /* read the input file(s) if specified */
        if( argc > first_file ) {
            xlsave( &expr, &lbda_env,  NULL ) ;
            expr.n_ptr = newnode( LIST ) ;
            expr.n_ptr->n_listvalue = newnode( STR ) ;
            for( i = first_file ; i < argc ; i++ ) {
                expr.n_ptr->n_listvalue->n_str = strsave( argv[i] ) ;
                load( expr.n_ptr ) ;
                strfree( expr.n_ptr->n_listvalue->n_str ) ; }
            expr.n_ptr->n_listvalue->n_str = NULL ; } }

    /* main command processing loop */
    while( TRUE ) {

        /* setup the error return */
        setjmp( xljmpbuf ) ;
        
        signal(SIGINT,usersigint);

        /* free any previous expression and leftover context */
        xlstack = xlenv = NULL ;

        /* create a new stack frame */
        xlsave( &expr, &lbda_env, NULL ) ;

        /* read an expression */
        expr.n_ptr = xlread( stdin ) ;

        /* evaluate the expression */
#ifdef USERTYPE
        expr.n_ptr = labeval( expr.n_ptr ) ;
#else
        expr.n_ptr = xleval( expr.n_ptr ) ;
#endif

        /* print its value */
        if (PP)  ppaux(expr.n_ptr,0,0);
        else     xlprint( expr.n_ptr, TRUE ) ;
        putchar( '\n' ) ; }
}
