#define sputc(c,S) {*(S++)=c;*S=0;}
#include "xmc.h"

static char * jjppaux( char* fp, SEXP vptr,int indent,int nl );
static char * jjxlprinterr( SEXP vptr, char*  fp);
#ifdef USERTYPE
static char * jjprint_type( struct t_table *tp , char *fp );
static char * jjprint_type1( struct t_table *tp , char *fp );
#endif
static char * jjxlprint(char* fp, SEXP vptr );
static char *null_str = "";
static char * indenta(int j,char* fp);

SEXP sexp2cam(char* fp, SEXP arg )
{
    fp = jjppaux(fp, arg ,0,0) ;
    sputc ('\n',fp);
    return( NULL ) ;
}

static char*  jjppaux( char* fp, SEXP vptr,int indent,int nl )
{
    struct node m2rec ;
    SEXP oldstk ;
    SEXP nptr, next ;
#ifdef USERTYPE
    extern struct t_table *name_table[] ;
    struct t_table *tdef ;
    struct lab_type *ptup ;
    SEXP tl ;
#endif

    /* print null as the empty list */
    if( vptr == NULL ) {
        fp += sprintf(fp, " {}" )  ;
        return fp; }

    /* check value type */
    switch( vptr->n_type ) {
#ifdef LAZY
    case REC :
        fp = jjppaux( fp,  xleval( vptr ) ,indent,nl) ;
        break ;
    case LISTREC :
        m2rec.n_ptr = vptr ;
        fp += sprintf( fp, "< " )  ;
        fp = jjppaux( fp,  xleval( m2rec.n_ptr->n_listvalue ) ,indent,nl) ;
        m2rec.n_ptr = m2rec.n_ptr->n_listnext ;
        do {
            m2rec.n_ptr = xleval( m2rec.n_ptr ) ;
            if( (m2rec.n_ptr != NULL) && (m2rec.n_ptr->n_type != LISTREC) )
                xlfail( "bad argument type" ) ;
            if( m2rec.n_ptr != NULL ) {
                sputc( ' ', fp ) ; 
                fp = jjppaux( fp,  xleval( m2rec.n_ptr->n_listvalue ) ,indent,nl) ;
                m2rec.n_ptr = m2rec.n_ptr->n_listnext ; }
        } while( m2rec.n_ptr != NULL ) ;
        sputc( '>', fp ) ; 
        sputc( '\n', fp ) ; 
        break ;
#endif
    case REL :
        if(nl==1) fp = indenta(indent,fp);
        nptr = vptr;
        fp += sprintf( fp, "[ " )  ;
        fp = jjppaux( fp,  nptr->n_listvalue->n_listvalue ,indent+3,0) ;
        sputc('<' , fp );
        sputc('-' , fp );
        sputc('>' , fp ) ; 
        sputc(' ' , fp ) ; 
        fp = jjppaux( fp,  nptr->n_listvalue->n_listnext->n_listvalue ,indent+6,0) ;
        next = nptr->n_listnext;
        for( nptr = next ; nptr != NULL ; nptr = next ) {
            fp = jjppaux( fp,  nptr->n_listvalue->n_listvalue ,indent+3,1) ;
            sputc('<' , fp );
            sputc('-' , fp );
            sputc('>' , fp ) ; 
            sputc(' ' , fp ) ; 
            fp = jjppaux( fp,  nptr->n_listvalue->n_listnext->n_listvalue ,indent+6,0) ;
            next = nptr->n_listnext; }
              fp += sprintf( fp, " ]" ) ;
        break ;
    case FF :
        if(nl==1) fp = indenta(indent,fp);
        nptr = vptr;
        fp += sprintf( fp, "[ " );
        fp = jjppaux( fp,  nptr->n_listvalue->n_listvalue ,indent+2,0) ;
        sputc('-' , fp );
        sputc('>' , fp ) ; 
        sputc(' ' , fp );
        fp = jjppaux( fp,  nptr->n_listvalue->n_listnext->n_listvalue ,indent+5,0) ;
        next = nptr->n_listnext;
        for( nptr = next ; nptr != NULL ; nptr = next ) {
            fp = jjppaux( fp,  nptr->n_listvalue->n_listvalue ,indent+2,1) ;
            sputc('-' , fp );
            sputc('>' , fp ) ; 
            sputc(' ' , fp );
            fp = jjppaux( fp,  nptr->n_listvalue->n_listnext->n_listvalue ,indent+5,0) ;
            next = nptr->n_listnext; }
            fp += sprintf( fp, "]" );
        break ;
    case SET :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf( fp, "{ " );
        nptr = vptr;
        fp = jjppaux( fp,  nptr->n_listvalue ,indent+2,0) ;
        for(nptr = nptr->n_listnext; nptr != NULL ; nptr = nptr->n_listnext ) {
            sputc( ' ', fp );
            fp = jjppaux( fp,  nptr->n_listvalue ,indent+2,0) ;}
        fp += sprintf( fp, "}" );
        break ;
    case LIST :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf( fp, "< " );
        nptr = vptr;
        fp = jjppaux( fp,  nptr->n_listvalue ,indent+2,0) ;
        for(nptr = nptr->n_listnext; nptr != NULL ; nptr = nptr->n_listnext ) {
            sputc( ' ', fp );
            fp = jjppaux( fp,  nptr->n_listvalue ,indent+2,0) ;}
        fp += sprintf( fp, ">" );
        break ;
    case SYM :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf( fp, "%s ", vptr->n_symname ) ;
        break ;
    case INT :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf( fp, "%d ", vptr->n_int );
        break ;
    case STR :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf(fp,"%s ", vptr->n_str ) ;
        break ;
    case SUBR :
    case FPTR :
#ifdef COMM
    case CHAN :
#endif
#ifdef USERTYPE
    case TYPE:
    case LABEL:
    case MACTYPE:
#endif
        fp = jjxlprint(fp, vptr) ;
        break;
    case FUN :
        if(nl==1) fp = indenta(indent,fp);
        fp += sprintf( fp, "lambda" );
        nptr = vptr;
        fp = jjxlprint(fp, nptr->n_listvalue) ;
        fp = indenta(indent+2,fp);
        nptr = nptr->n_listnext; 
        fp = jjxlprint(fp, nptr->n_listvalue) ;
        break ;
    default:
#ifdef USERTYPE
        /*if(nl==1) fp = indenta(indent,fp); */
        fp = indenta(indent,fp);
        if( vptr->n_type >= USERDEFTYPE ) {
            tdef = name_table[vptr->n_type - USERDEFTYPE] ;
            fp += sprintf( fp, "%s( ", tdef->tname );
            if( tdef->tnumber == TTUP ) {
                if( ((tl = vptr->n_symvalue) == NULL) || (tl->n_type != LIST) )
                    xlfail( "type mismatch" ) ;
                for( ptup = tdef->def.tcomp ; (ptup != NULL) && (tl != NULL);
                               ptup = ptup->next )
                    { fp = jjppaux( fp,  tl->n_listvalue ,indent+3,1) ;
                      if( (tl = tl->n_listnext) != NULL )
                        sputc(',',fp); }
                if( (ptup != NULL) || (tl != NULL) )
                    xlfail( "type mismatch" ) ; }
            else
                fp = jjppaux( fp,  vptr->n_symvalue ,indent+3,0) ;
            sputc( ')', fp ) ;  }
        else
#endif
        xlfail( "bad node type" ) ; }

   return fp;
}

/*. jjxlprinterr - print an xlisp value .*/
static char * jjxlprinterr( SEXP vptr, char*  fp)
{
#ifdef LAZY
    struct node m2rec ;
    SEXP oldstk ;
#endif
#ifdef USERTYPE
    SEXP prval ;
#endif
    SEXP nptr, next ;
#ifdef FGETNAME 
    char buffer[128] ;
#endif

#ifdef LAZY
#endif

    /* print null as the empty list */
    if( vptr == NULL ) {
        fp += sprintf(fp, "()" ) ;
        return fp; }

    /* check value type */
    switch( vptr->n_type ) {
    case SUBR :
        fp += sprintf(fp, "<Subr: #%o>", vptr ) ;
        break ;
#ifdef LAZY
    case REC :
#ifdef USERTYPE
        fp = jjxlprinterr( labeval( vptr ), fp) ;
#else
        fp = jjxlprinterr( xleval( vptr ), fp) ;
#endif
        break ;
    case LISTREC :
        m2rec.n_ptr = vptr ;
        sputc( '(' ,fp) ;
#ifdef USERTYPE
        fp = jjxlprinterr( labeval( m2rec.n_ptr->n_listvalue ), fp) ;
#else
        fp = jjxlprinterr( xleval( m2rec.n_ptr->n_listvalue ), fp) ;
#endif
        m2rec.n_ptr = m2rec.n_ptr->n_listnext ;
        do {
            m2rec.n_ptr = xleval( m2rec.n_ptr ) ;
            if( (m2rec.n_ptr != NULL) && (m2rec.n_ptr->n_type != LISTREC) )
                xlfail( "bad argument type" ) ;
            if( m2rec.n_ptr != NULL ) {
                sputc( ' ' ,fp) ;
#ifdef USERTYPE
                fp = jjxlprinterr( labeval( m2rec.n_ptr->n_listvalue ), fp) ;
#else
                fp = jjxlprinterr( xleval( m2rec.n_ptr->n_listvalue ), fp) ;
#endif
                m2rec.n_ptr = m2rec.n_ptr->n_listnext ; }
        } while( m2rec.n_ptr != NULL ) ;
        sputc( ')' ,fp) ;
        break ;
#endif
    case SET :
    case REL :
    case FF :
    case FUN :
    case LIST :
        sputc( '(' ,fp) ;
        for( nptr = vptr ; nptr != NULL ; nptr = next ) {
#ifdef USERTYPE
            prval = nptr->n_listvalue ;
            while( (prval != NULL) && (prval->n_type >= USERDEFTYPE) )
                prval = prval->n_symvalue ;
            fp = jjxlprinterr( prval, fp) ;
#else
            fp = jjxlprinterr( nptr->n_listvalue, fp) ;
#endif
            if( (next = nptr->n_listnext) != NULL )
                sputc( ' ' ,fp) ; }
        sputc( ')' ,fp) ;
        break ;
    case SYM :
        fp += sprintf(fp, "%s", vptr->n_symname ) ;
        break ;
    case INT :
        fp += sprintf(fp, "%d", vptr->n_int ) ;
        break ;
    case STR :
            fp += sprintf(fp, "%s", vptr->n_str ) ;
        break ;
    case FPTR :
#ifdef FGETNAME
        fp += sprintf(fp, "<File: %s>", fgetname( vptr->n_fp, buffer ) ) ;
#else
        fp += sprintf(fp, "<File: #%o>", vptr ) ;
#endif
        break;
#ifdef COMM
    case CHAN :
        fp += sprintf(fp, "<Channel: " ) ;
        fp = jjxlprinterr( vptr->n_qname, fp) ;
        fp += sprintf(fp, " %d>", vptr->n_qid ) ;
        break ;
#endif
#ifdef USERTYPE
    case TYPE :
        fp += sprintf(fp, "<Type: " ) ;
        fp = jjprint_type( vptr->n_typedef, fp ) ;
        fp += sprintf(fp, ">" ) ;
        break ;
    case LABEL :
        fp += sprintf(fp, "<Label>" ) ;
        break ;
    case MACTYPE:
        fp += sprintf(fp, "<Mactype: " ) ;
        for( nptr = vptr->n_macdef ; nptr != NULL ; nptr = next ) {
            fp = jjxlprinterr( nptr->n_listvalue, fp) ;
            if( (next = nptr->n_listnext) != NULL )
                sputc( ' ' ,fp) ; }
        fp += sprintf(fp, ">" ) ;
        break ;
#endif
    default:
        xlfail( "bad node type" ) ; }

#ifdef LAZY
#endif
 return fp;
}

/*. jjxlprint - print an xlisp value .*/
static char* jjxlprint(char* fp, SEXP vptr )
{ return jjxlprinterr(vptr,fp);
}

/*. fp = jjprint_type1 - writes tp name or definition on file fp .*/
static char * jjprint_type1( struct t_table *tp , char *fp )
{
if( tp->tname == null_str )
    switch( tp->tnumber ) {
    case TNIL:
         fp += sprintf( fp, "NIL" ) ;
         break ;
    case TANY:
         fp += sprintf( fp, "ANY" ) ;
         break ;
    case TSYM:
         fp += sprintf( fp, "SYM" ) ;
         break ;
    case TINT:
         fp += sprintf( fp, "INT" ) ;
         break ;
    case TSTR:
         fp += sprintf( fp, "STR" ) ;
         break ;
    case TFPTR:
         fp += sprintf( fp, "FPTR" ) ;
         break ;
#ifdef COMM
    case TCHAN:
         fp += sprintf( fp, "CHAN" ) ;
         break ;
#endif
    case TSET:
         fp += sprintf( fp, "SET " ) ;
         fp = jjprint_type1( tp->def.type, fp ) ;
         break ;
    case TLIST:
         fp += sprintf( fp, "LIST " ) ;
         fp = jjprint_type1( tp->def.type, fp ) ;
         break ;
    case TREL:
         fp += sprintf( fp, "REL " ) ;
         fp = jjprint_type1( tp->def.rel.dom, fp ) ;
         fp += sprintf( fp, " " ) ;
         fp = jjprint_type1( tp->def.rel.ran, fp ) ;
         break ;
    case TFF:
         fp += sprintf( fp, "FF " ) ;
         fp = jjprint_type1( tp->def.rel.dom, fp ) ;
         fp += sprintf( fp, " " ) ;
         fp = jjprint_type1( tp->def.rel.ran, fp ) ;
         break ;
    default:
         xlfail( "bad type" ) ; }
else
    fp += sprintf( fp, "%s", tp->tname ) ;

return fp;
}

static char *  jjprint_type( struct t_table *tp , char *fp )
{
    struct type *pa ;
    struct lab_type *pt ;

    switch( tp->tnumber ) {
    case TUNDEF:
         fp += sprintf( fp, "undefined_type" ) ;
         break ;
    case TANY:
         fp += sprintf( fp, "ANY" ) ;
         break ;
    case TNIL:
         fp += sprintf( fp, "NIL" ) ;
         break ;
    case TSYM:
         fp += sprintf( fp, "SYM" ) ;
         break ;
    case TINT:
         fp += sprintf( fp, "INT" ) ;
         break ;
    case TSTR:
         fp += sprintf( fp, "STR" ) ;
         break ;
    case TFPTR:
         fp += sprintf( fp, "FPTR" ) ;
         break ;
#ifdef COMM
    case TCHAN:
         fp += sprintf( fp, "CHAN" ) ;
         break ;
#endif
    case TSET:
         fp += sprintf( fp, "SET " ) ;
         fp = jjprint_type1( tp->def.type, fp ) ;
         break ;
    case TLIST:
         fp += sprintf( fp, "LIST " ) ;
         fp = jjprint_type1( tp->def.type, fp ) ;
         break ;
    case TEQ:
         fp += sprintf( fp, "EQ %s", tp->def.type->tname ) ;
         break ;
    case TREL:
         fp += sprintf( fp, "REL " ) ;
         fp = jjprint_type1( tp->def.rel.dom, fp ) ;
         fp += sprintf( fp, " " ) ;
         fp = jjprint_type1( tp->def.rel.ran, fp ) ;
         break ;
    case TFF:
         fp += sprintf( fp, "FF " ) ;
         fp = jjprint_type1( tp->def.rel.dom, fp ) ;
         fp += sprintf( fp, " " ) ;
         fp = jjprint_type1( tp->def.rel.ran, fp ) ;
         break ;
    case TALT:
         fp += sprintf( fp, "ALT" ) ;
         for( pa = tp->def.acomp; pa != NULL; pa = pa->next ) {
             fp += sprintf( fp, " " ) ;
             fp = jjprint_type1( pa->type, fp ) ; }
         break ;
    case TTUP:
         fp += sprintf( fp, "TUP" ) ;
         for( pt = tp->def.tcomp; pt != NULL; pt = pt->next ) {
             fp += sprintf( fp, " (%s ", pt->label ) ;
             fp = jjprint_type1( pt->type, fp ) ;
             fp += sprintf( fp, ")" ) ; }
         break ;
    default:
         xlfail( "bad type" ) ; }
 return fp;
}

static char * indenta(int j, char* fp)
{ int i; 
  sputc('\n',fp) ;
  for(i=0 ;i<j ; i++) sputc(' ',fp);
  return fp;
}

#undef sputc
