#include <stdio.h>
#include "xmc.h"

#include "xmunderground.h"

/* curry : exp any-seq -> any */
/*
SEXP curry2( args )
SEXP args ;
{
   SEXP fun,expr;
   fun  = arg_n(1,args,0);
   if (!fun) xlfail("invalid function");
   expr = arg_n(2,args,LIST);
   return xleval(conssexp(fun,expr));
}
*/

SEXP unbless( args )
SEXP args ;
{
   SEXP fun,a;
/*   return xleval(l2sexp(args->n_head, f1("quote",args->n_tail))); */
   fun = args->n_head;
   a = args->n_tail;
   return xleval(l2sexp(fun, conssexp(symsexp("list"),a))); 
}

/*. jjmakecopy - copy an exp created by "xlread" .*/
struct node *jjmakecopy( exp )
struct node *exp ;
{    struct node *new ;
    if( exp == NULL ) return( NULL ) ;
    if( exp->n_type != LIST ) xlfail("invalid list");
    else { new = newnode( LIST ) ;
           new->n_listvalue = exp->n_listvalue;
           new->n_listnext  = jjmakecopy(exp->n_listnext);
           return new;
    }
}

static SEXP quoteSymAndList(SEXP x)
{
  SEXP r=jjmakecopy(x);
  SEXP l=r;
  for(     ; l != NULL  ; l = l->n_tail)
  {
         if(l->n_head->n_type ==  LIST ) l->n_head = f1("quote",l->n_head) ;
    else if(l->n_head->n_type ==  SYM ) l->n_head = f1("quote",l->n_head)  ;
    else if(l->n_head->n_type ==  LABEL ) l->n_head = f1("quote",l->n_head);
#ifdef USERTYPE
    else if(l->n_head->n_type >=USERDEFTYPE)l->n_head=f1("quote",l->n_head);
#endif
    else if(l->n_head->n_type ==  TYPE ) l->n_head = f1("quote",l->n_head) ;
  }
  return(r);
}

/* bless : exp any-seq -> any */
SEXP bless( args )
SEXP args ;
{
   SEXP fun,expr,val;
   fun  = arg_n(1,args,0);
   if (!fun) xlfail("invalid function");
   expr = arg_n(2,args,LIST);
   if(expr == XM_ERROR) return XM_ERROR;
   /* ppaux(val,0,0); */
   return xleval(conssexp(fun,quoteSymAndList(expr)));
}

void userinit2(){
int i;
SEXP x;
   xlsubr( "bless", bless ) ;
   xlsubr( "tup2arg", bless ) ;
   xlsubr( "arg2tup", unbless ) ;

   for(i=0;strcmp(xxx[i],""); i++){
   x = libxmevalstr(xxx[i]);
   if (x == XM_ERROR) puts("error");}
}
